      SUBROUTINE DE42D(F,M,JSTART,HMIN,HMAX,EPS,P,YX,X,DY,H,
     1BUL,DELTY,DF,RFN,RF,YP,DYP,IERR)
      DIMENSION YX(M),DY(M),DELTY(M),DF(M,5),RFN(M),RF(M),
     1YP(M),DYP(M)
      INTEGER M,JSTART,IERR,IORDER,IM,IN,JER,I,K,K1,L
      DOUBLE PRECISION HMIN,HMAX,EPS,P,YX,X,DY,H,DELTY,DF,
     1RFN,RF,YP,DYP,XOLD,C1,C2,C4,C5,C6,EPS1,EPS2,HNEW,ALP,
     1HOLD,RH,DSIGN,DABS
      LOGICAL BUL,BUL1,BUL2
      SAVE
      DATA  C1,C2,C4,C5,C6/12.D0,0.083333333333333D0,-
     10.05D0,20.D0,0.3125D0/
      L=1
      BUL1=.FALSE.
      EPS1=C5*EPS
      EPS2=C6*EPS
      IF(JSTART.GE.0) GO TO 4
      IM=0
      IF(IERR.EQ.0) GO TO 1
      IERR=0
      GO TO 6
    1 ALP=HOLD/HNEW
      IF(ALP.EQ.0.5D0) CALL DE42DP(M,IORDER,ALP,DF,DY)
      HNEW=HOLD
      DO 2 K=1,4
      K1=K+1
      DO 2 I=1,M
      DF(I,K)=DF(I,K)-DF(I,K1)
    2 CONTINUE
      DO 3 I=1,M
      DY(I)=DYP(I)
    3 CONTINUE
      GO TO 6
    4 XOLD=X
      DO 5 I=1,M
      YP(I)=YX(I)
      DYP(I)=DY(I)
    5 CONTINUE
      IERR=0
      IF(JSTART.NE.0) GO TO 6
      IM=0
      IORDER=5
      CALL F(X,YX,RF,M)
      CALL DE34D(F,M,IORDER,XOLD,YP,DYP,HMIN,EPS,P,H,X,YX,
     1DY,DF,RFN,RF,DELTY,JER)
      IF(JER.NE.0) IERR=66
      GO TO 26
    6 IF(H.EQ.HNEW) GO TO 7
      ALP=H/HNEW
      CALL DE42DP(M,IORDER,ALP,DF,DY)
    7 DO 8 I=1,M
      RF(I)=DF(I,3)+DF(I,4)
      YX(I)=YP(I)+DY(I)+C1*DF(I,1)+RF(I)
      RF(I)=RF(I)+DF(I,1)+DF(I,2)
    8 CONTINUE
      RH=C2*H**2
      IN=0
      X=XOLD+H
    9 DO 10 I=1,M
      DELTY(I)=-RF(I)
   10 CONTINUE
      CALL F(X,YX,RF,M)
      BUL2=.TRUE.
      DO 12 I=1,M
      RF(I)=RF(I)*RH
      DELTY(I)=DELTY(I)+RF(I)
      YX(I)=DELTY(I)+YX(I)
      IF(DABS(YX(I)).LE.P) GO TO 11
      DELTY(I)=DELTY(I)/YX(I)
   11 IF(DABS(DELTY(I)).GT.EPS) BUL2=.FALSE.
   12 CONTINUE
      IF(BUL2) GO TO 18
      DO 13 I=1,M
      IF(DABS(DELTY(I)).GT.EPS1) GO TO 14
   13 CONTINUE
      IN=IN+1
      IF(IN.LT.2) GO TO 9
   14 IF(.NOT.BUL1) GO TO 15
      IERR=65
      GO TO 26
   15 H=H*0.5D0
      BUL=.FALSE.
      IF(DABS(H).GT.DABS(HMIN)) GO TO 16
      BUL1=.TRUE.
      ALP=DSIGN(HMIN,H)*0.5D0/H
      H=DSIGN(HMIN,H)
      GO TO 17
   16 ALP=0.5D0
   17 CALL DE42DP(M,IORDER,ALP,DF,DY)
      IM=2
      GO TO 7
   18 CALL DE28DS(M,IORDER,RF,DF,DELTY)
      HOLD=H
      DO 19 I=1,M
      DYP(I)=DY(I)
      DY(I)=YX(I)-YP(I)
      DELTY(I)=DF(I,5)*C4
      YX(I)=YX(I)+DELTY(I)
   19 CONTINUE
   20 DO 22 I=1,M
      DELTY(I)=DF(I,5)*C4
      IF(DABS(YX(I)).LE.P) GO TO 21
      DELTY(I)=DELTY(I)/YX(I)
   21 IF(DABS(DELTY(I)).GT.EPS2) GO TO 25
   22 CONTINUE
      IM=IM+1
      IF(IM.NE.3) GO TO 26
      H=H*2.D0
      BUL1=.FALSE.
      IF(DABS(H).LE.DABS(HMAX)) GO TO 23
      ALP=DSIGN(HMAX,H)*2.D0/H
      H=DSIGN(HMAX,H)
      GO TO 24
   23 ALP=2.D0
   24 CALL DE42DP(M,IORDER,ALP,DF,DY)
      IM=0
      GO TO 20
   25 IM=0
   26 IF(IERR.NE.0) CALL UTDE13(IERR,42)
      JSTART=1
      HNEW=H
      RETURN
      END
